#ifndef _NWK_H
#define _NWK_H

/* LCE message types */
enum dect_lce_msg_types {
	DECT_LCE_PAGE_RESPONSE			= 0x71,
	DECT_LCE_PAGE_REJECT			= 0x72,
};

/**
 * Call Control message types
 */
enum dect_cc_msg_types {
	DECT_CC_RESERVED			= 0x0,
	DECT_CC_ALERTING			= 0x1,
	DECT_CC_CALL_PROC			= 0x2,
	DECT_CC_SETUP				= 0x5,
	DECT_CC_CONNECT				= 0x7,
	DECT_CC_SETUP_ACK			= 0xd,
	DECT_CC_CONNECT_ACK			= 0xf,
	DECT_CC_SERVICE_CHANGE			= 0x20,
	DECT_CC_SERVICE_ACCEPT			= 0x21,
	DECT_CC_SERVICE_REJECT			= 0x22,
	DECT_CC_RELEASE				= 0x4d,
	DECT_CC_RELEASE_COM			= 0x5a,
	DECT_CC_IWU_INFO			= 0x60,
	DECT_CC_NOTIFY				= 0x6e,
	DECT_CC_INFO				= 0x7b,
};

/**
 * Call Independant Supplementary Services messages types
 */
enum dect_ciss_msg_types {
	DECT_CISS_RELEASE_COM			= 0x5a,
	DECT_CISS_FACILITY			= 0x62,
	DECT_CISS_REGISTER			= 0x64,
};

/**
 * MM message types
 */
enum dect_mm_msg_types {
	DECT_MM_AUTHENTICATION_REQUEST		= 0x40,
	DECT_MM_AUTHENTICATION_REPLY		= 0x41,
	DECT_MM_KEY_ALLOCATE			= 0x42,
	DECT_MM_AUTHENTICATION_REJECT		= 0x43,
	DECT_MM_ACCESS_RIGHTS_REQUEST		= 0x44,
	DECT_MM_ACCESS_RIGHTS_ACCEPT		= 0x45,
	DECT_MM_ACCESS_RIGHTS_REJECT		= 0x47,
	DECT_MM_ACCESS_RIGHTS_TERMINATE_REQUEST	= 0x48,
	DECT_MM_ACCESS_RIGHTS_TERMINATE_ACCEPT	= 0x49,
	DECT_MM_ACCESS_RIGHTS_TERMINATE_REJECT	= 0x4b,
	DECT_MM_CIPHER_REQUEST			= 0x4c,
	DECT_MM_CIPHER_SUGGEST			= 0x4e,
	DECT_MM_CIPHER_REJECT			= 0x4f,
	DECT_MM_INFO_REQUEST			= 0x50,
	DECT_MM_INFO_ACCEPT			= 0x51,
	DECT_MM_INFO_SUGGEST			= 0x52,
	DECT_MM_INFO_REJECT			= 0x53,
	DECT_MM_LOCATE_REQUEST			= 0x54,
	DECT_MM_LOCATE_ACCEPT			= 0x55,
	DECT_MM_DETACH				= 0x56,
	DECT_MM_LOCATE_REJECT			= 0x57,
	DECT_MM_IDENTITY_REQUEST		= 0x58,
	DECT_MM_IDENTITY_REPLY			= 0x59,
	DECT_MM_IWU				= 0x5b,
	DECT_MM_TEMPORARY_IDENTITY_ASSIGN	= 0x5c,
	DECT_MM_TEMPORARY_IDENTITY_ASSIGN_ACK	= 0x5d,
	DECT_MM_TEMPORARY_IDENTITY_ASSIGN_REJ	= 0x5f,
};

#endif /* _NWK_H */
